#pragma once

#include <TrackingSystem.hpp>

#include <deque>
#include <string>
#include <vector>

class WrappedTrackingSystem : public atracsys::TrackingSystem
{
public:
    WrappedTrackingSystem( uint32 timeout = 100u, bool allowSimulator = true );

    virtual ~WrappedTrackingSystem() = default;

    atracsys::Status initialise( const std::string& fileName = "" );

    void streamLastError();

    std::vector< atracsys::DeviceInfo > getEnumeratedDevices() const;

    std::vector< atracsys::DeviceOption > getEnumeratedOptions( uint64 sn ) const;

    std::vector< atracsys::DeviceOption > getEnumeratedOptions() const;

    int32 getIntOption( uint64 serialNbr, uint32 optId, ftkOptionGetter what ) const;
    int32 getIntOption( uint64 serialNbr, uint32 optId ) const;
    int32 getIntOption( uint32 optId, ftkOptionGetter what ) const;
    int32 getIntOption( uint32 optId ) const;
    int32 getIntOption( uint64 serialNbr, const std::string& optId, ftkOptionGetter what ) const;
    int32 getIntOption( uint64 serialNbr, const std::string& optId ) const;
    int32 getIntOption( const std::string& optId, ftkOptionGetter what ) const;
    int32 getIntOption( const std::string& optId ) const;

    float getFloatOption( uint64 serialNbr, uint32 optId, ftkOptionGetter what ) const;
    float getFloatOption( uint64 serialNbr, uint32 optId ) const;
    float getFloatOption( uint32 optId, ftkOptionGetter what ) const;
    float getFloatOption( uint32 optId ) const;
    float getFloatOption( uint64 serialNbr, const std::string& optId, ftkOptionGetter what ) const;
    float getFloatOption( uint64 serialNbr, const std::string& optId ) const;
    float getFloatOption( const std::string& optId, ftkOptionGetter what ) const;
    float getFloatOption( const std::string& optId ) const;

    std::string getDataOption( uint64 serialNbr, uint32 optId ) const;
    std::string getDataOption( uint32 optId ) const;
    std::string getDataOption( uint64 serialNbr, const std::string& optId ) const;
    std::string getDataOption( const std::string& optId ) const;
};
